Public Class frmTicTacToe
  Dim BoxArray(9) As Label
  Dim XTurn As Boolean
  Dim CanClick As Boolean = False
  Dim NumberClicks As Integer
  Dim PossibleWins(8) As String
  Dim GameOver As Boolean
  Dim MyRandom As New Random
  Dim DrawSound As System.Media.SoundPlayer
  Dim WinSound As System.Media.SoundPlayer



  Private Sub frmTicTacToe_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim I As Integer
    'establish array
    BoxArray(1) = lblBox1
    BoxArray(2) = lblBox2
    BoxArray(3) = lblBox3
    BoxArray(4) = lblBox4
    BoxArray(5) = lblBox5
    BoxArray(6) = lblBox6
    BoxArray(7) = lblBox7
    BoxArray(8) = lblBox8
    BoxArray(9) = lblBox9
    'possible wins
    PossibleWins(1) = "123"
    PossibleWins(2) = "456"
    PossibleWins(3) = "789"
    PossibleWins(4) = "147"
    PossibleWins(5) = "258"
    PossibleWins(6) = "369"
    PossibleWins(7) = "159"
    PossibleWins(8) = "357"
    'clear boxes
    For I = 1 To 9
      BoxArray(I).Text = ""
    Next
    lblMessage.Text = "Game Stopped"
    grpFirst.Enabled = False
    grpComputer.Enabled = False
    DrawSound = New System.Media.SoundPlayer(Application.StartupPath + "\beep.wav")
    WinSound = New System.Media.SoundPlayer(Application.StartupPath + "\tada.wav")
  End Sub

  Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
    Me.Close()
  End Sub

  Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
    Dim I As Integer
    If btnStartStop.Text = "Start Game" Then
      btnStartStop.Text = "Stop Game"
      grpPlayers.Enabled = False
      grpFirst.Enabled = False
      grpComputer.Enabled = False
      btnExit.Enabled = False
      XTurn = True
      lblMessage.Text = "X's Turn"
      'reset boxes
      For I = 1 To 9
        BoxArray(I).Text = ""
        BoxArray(I).BackColor = Color.White
      Next I
      CanClick = True
      NumberClicks = 0
      GameOver = False
      If rdoComputerFirst.Checked Then
        ComputerTurn()
      End If
    Else
      btnStartStop.Text = "Start Game"
      If Not (GameOver) Then
        lblMessage.Text = "Game Stopped"
      End If
      grpPlayers.Enabled = True
      If rdoOnePlayer.Checked Then
        grpFirst.Enabled = True
        grpComputer.Enabled = True
      End If
      btnExit.Enabled = True
      CanClick = False
    End If
  End Sub

  Private Sub lblBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblBox1.Click, lblBox9.Click, lblBox8.Click, lblBox7.Click, lblBox6.Click, lblBox5.Click, lblBox4.Click, lblBox3.Click, lblBox2.Click
    Dim I As Integer
    Dim WhoWon As String = ""
    If CanClick Then
      'see which box is clicked
      Dim ClickedBox As Label
      ClickedBox = CType(sender, Label)
      'last digit of name is number
      I = Val(Mid(ClickedBox.Name, Len(ClickedBox.Name), 1))
      'if already clicked then exit
      If BoxArray(I).Text <> "" Then Exit Sub
      NumberClicks += 1
      If XTurn Then
        BoxArray(I).Text = "X"
        XTurn = False
        lblMessage.Text = "O's Turn"
      Else
        BoxArray(I).Text = "O"
        XTurn = True
        lblMessage.Text = "X's Turn"
      End If
      'check for win - will establish a value for WhoWon
      WhoWon = CheckForWin()
      If WhoWon <> "" Then
        WinSound.Play()
        lblMessage.Text = WhoWon + " wins!"
        GameOver = True
        btnStartStop.PerformClick()
        Exit Sub
      ElseIf NumberClicks = 9 Then
        'draw
        DrawSound.Play()
        lblMessage.Text = "It's a draw!"
        GameOver = True
        btnStartStop.PerformClick()
        Exit Sub
      End If
      If rdoOnePlayer.Checked Then
        If (XTurn And rdoComputerFirst.Checked) Or (Not (XTurn) And rdoYouFirst.Checked) Then
          ComputerTurn()
        End If
      End If
    End If
  End Sub
  Private Function CheckForWin() As String
    Dim Winner As String = ""
    Dim BoxNumber(3) As Integer
    Dim Mark(3) As String
    Dim I As Integer, J As Integer
    'check all possible for win
    For I = 1 To 8
      For J = 1 To 3
        BoxNumber(J) = Val(Mid(PossibleWins(I), J, 1))
        Mark(J) = BoxArray(BoxNumber(J)).Text
      Next J
      If Mark(1) = Mark(2) And Mark(1) = Mark(3) And Mark(2) = Mark(3) And Mark(1) <> "" Then
        'we have a winner
        Winner = Mark(1)
        For J = 1 To 3
          BoxArray(BoxNumber(J)).BackColor = Color.Red
        Next J
      End If
    Next I
    Return (Winner)
  End Function


  Private Sub rdoOnePlayer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoOnePlayer.Click
    grpFirst.Enabled = True
    grpComputer.Enabled = True
  End Sub

  Private Sub rdoTwoPlayers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoTwoPlayers.Click
    grpFirst.Enabled = False
    grpComputer.Enabled = False
  End Sub
  Private Sub ComputerTurn()
    Dim SelectedBox As Integer
    Dim I As Integer, N As Integer
    Dim J As Integer, K As Integer
    Dim ComputerMark As String, PlayerMark As String, MarkToFind As String
    Dim BoxNumber(3) As Integer
    Dim Mark(3) As String
    Dim EmptyBox As Integer
    Dim BestMoves() As Integer = {5, 1, 3, 7, 9, 2, 4, 6, 8}

    'random logic
    If rdoRandom.Checked Then
      'put mark in Nth available square
      N = MyRandom.Next(9 - NumberClicks) + 1
      I = 0
      For SelectedBox = 1 To 9
        If BoxArray(SelectedBox).Text = "" Then
          I += 1
          If I = N Then
            Exit For
          End If
        End If
      Next SelectedBox
      'put mark in SelectedBox
      lblBox_Click(BoxArray(SelectedBox), Nothing)
    Else
      'smart computer
      'determine who has what mark
      If rdoComputerFirst.Checked Then
        ComputerMark = "X"
        PlayerMark = "O"
      Else
        ComputerMark = "O"
        PlayerMark = "X"
      End If

      'Step 1 (K = 1) - check for win - see if two boxes hold computer mark and one is empty
      'Step 2 (K = 2) - check for block - see if two boxes hold player mark and one is empty
      For K = 1 To 2
        If K = 1 Then
          MarkToFind = ComputerMark
        Else
          MarkToFind = PlayerMark
        End If
        For I = 1 To 8
          N = 0
          EmptyBox = 0
          For J = 1 To 3
            BoxNumber(J) = Val(Mid(PossibleWins(I), J, 1))
            Mark(J) = BoxArray(BoxNumber(J)).Text
            If Mark(J) = MarkToFind Then
              N += 1
            ElseIf Mark(J) = "" Then
              EmptyBox = BoxNumber(J)
            End If
          Next J
          If N = 2 And EmptyBox <> 0 Then
            'mark empty box to win (K = 1) or block (K = 2)
            lblBox_Click(BoxArray(EmptyBox), Nothing)
            Exit Sub
          End If
        Next I
      Next K

      'Step 3 - find next best move
      For I = 0 To 8
        If BoxArray(BestMoves(I)).Text = "" Then
          lblBox_Click(BoxArray(BestMoves(I)), Nothing)
          Exit Sub
        End If
      Next
    End If
  End Sub

 
End Class
